/*  Project partsasm
	Project Team DoGA
	Copyright (c) 1995. All Rights Reserved.

	TuVXe:    partsasm.apx Application
	t@C:        bmpbtn.cpp
	쐬:          Taka2


	Tv
	====
	TBitmapButton (TButton) ̃Cve[Vp̃\[Xt@C
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include "bmpbtn.h"
#include "design.h"
#include "parts.h"
#include "winframe.h"
#include "seltype.h"
#include "log.h"

const int buttonsize = 16;

//
// ̃AvP[Vŏ邷ׂẴbZ[W^R}h
// e[u쐬
//
DEFINE_RESPONSE_TABLE1(TBitmapButton, TButton)
//{{TBitmapButtonRSP_TBL_BEGIN}}
	EV_WM_PAINT,
    EV_WM_TIMER,
//{{TBitmapButtonRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TBitmapButton Implementation}}


TBitmapButton::TBitmapButton (TWindow* parent, DesignData *dd, int id, int X, int Y, int W, int H, BOOL isDefault, TModule* module):
	TButton(parent, id, "", X, Y, W, H, isDefault, module)
{
	// TButton ṕCftHg̃EBhEX^CI[o[Ch
	Attr.Style |= WS_CHILD | WS_VISIBLE;
	Attr.Style &= ~(WS_MAXIMIZEBOX | WS_MINIMIZEBOX);

	// INSERT>> RXgN^p̃R[h͂

	Attr.Style |= BS_OWNERDRAW;
	dib = new TDib(*GetModule(), id);

    designdata = dd;
}


TBitmapButton::~TBitmapButton ()
{
	Destroy();

	// INSERT>> fXgN^p̃R[h͂
	delete dib;
}


void TBitmapButton::EvPaint ()
{
	TButton::EvPaint();

	// INSERT>> ǉR[h͂
	TClientDC dc(*this);
	TSize s = dib->Size();
	TRect imageRect(0,0, s.cx, s.cy);
	if (Attr.W == s.cx && Attr.H == s.cy) {
		dc.SetDIBitsToDevice(imageRect, TPoint(0,0), *dib);
	} else {
		TRect clientRect(0,0, Attr.W, Attr.H);
		dc.StretchDIBits(clientRect, imageRect, *dib);
	}
}


void TBitmapButton::SetupWindow ()
{
	TButton::SetupWindow();

	// INSERT>> ǉ̃R[h͂
}




void TBitmapButton::ODADrawEntire (DRAWITEMSTRUCT far& drawInfo)
{
    TButton::ODADrawEntire(drawInfo);

    // INSERT>> ǉ̃R[h͂

}


void TBitmapButton::ODAFocus (DRAWITEMSTRUCT far& drawInfo)
{
	TButton::ODAFocus(drawInfo);

	// INSERT>> ǉ̃R[h͂

}


void TBitmapButton::ODASelect (DRAWITEMSTRUCT far& drawInfo)
{
	TButton::ODASelect(drawInfo);

	// INSERT>> ǉ̃R[h͂

	if (drawInfo.itemState & ODS_SELECTED) {
		if (designdata->select == designdata->camera) {
			designdata->Frame->EvButton(Attr.Id, SelPers | SelStat);
		} else {
			designdata->Frame->EvButton(Attr.Id, SelPers);
		}
		SetTimer(0,100);
	} else {
		KillTimer(0);
		designdata->Redraw(SelXYZ);
	}
}


void TBitmapButton::EvTimer (UINT timerId)
{
	TButton::EvTimer(timerId);

	// INSERT>> ǉR[h͂

	if (designdata->select == designdata->camera) {
		designdata->Frame->EvButton(Attr.Id, SelPers | SelStat);
	} else {
		designdata->Frame->EvButton(Attr.Id, SelPers);
	}
}

